From ba951c552265d98ca2a4c1e2d4b9845481cbd8fa Mon Sep 17 00:00:00 2001
From: Chris Johns <chrisj@rtems.org>
Date: Mon, 2 Aug 2021 18:15:35 +1000
Subject: [PATCH rtems-libbsd v4 03/19] sys/netinet/libalias: Fix symbols
 clashes

Update #4475
---
 freebsd/sys/netinet/libalias/alias_cuseeme.c | 3 +++
 freebsd/sys/netinet/libalias/alias_dummy.c   | 4 +++-
 freebsd/sys/netinet/libalias/alias_ftp.c     | 3 +++
 freebsd/sys/netinet/libalias/alias_irc.c     | 3 +++
 freebsd/sys/netinet/libalias/alias_nbt.c     | 3 +++
 freebsd/sys/netinet/libalias/alias_pptp.c    | 3 +++
 freebsd/sys/netinet/libalias/alias_skinny.c  | 3 +++
 freebsd/sys/netinet/libalias/alias_smedia.c  | 3 +++
 8 files changed, 24 insertions(+), 1 deletion(-)

diff --git a/freebsd/sys/netinet/libalias/alias_cuseeme.c b/freebsd/sys/netinet/libalias/alias_cuseeme.c
index 1d62a696..64a225fa 100644
--- a/freebsd/sys/netinet/libalias/alias_cuseeme.c
+++ b/freebsd/sys/netinet/libalias/alias_cuseeme.c
@@ -95,6 +95,9 @@ protohandlerout(struct libalias *la, struct ip *pip, struct alias_data *ah)
 }
 
 /* Kernel module definition. */
+#ifdef __rtems__
+static
+#endif /* __rtems__ */
 struct proto_handler handlers[] = {
 	{
 	  .pri = 120,
diff --git a/freebsd/sys/netinet/libalias/alias_dummy.c b/freebsd/sys/netinet/libalias/alias_dummy.c
index 19f8430d..608db930 100644
--- a/freebsd/sys/netinet/libalias/alias_dummy.c
+++ b/freebsd/sys/netinet/libalias/alias_dummy.c
@@ -105,6 +105,9 @@ protohandler(struct libalias *la, struct ip *pip, struct alias_data *ah)
  * ITS EXACT NAME: handlers.
  */
 
+#ifdef __rtems__
+static
+#endif /* __rtems__ */
 struct proto_handler handlers [] = {
 	{
 	  .pri = 666,
@@ -154,4 +157,3 @@ AliasHandleDummy(struct libalias *la, struct ip *ip, struct alias_data *ah)
 {
 	; /* Dummy. */
 }
-
diff --git a/freebsd/sys/netinet/libalias/alias_ftp.c b/freebsd/sys/netinet/libalias/alias_ftp.c
index 4a86139e..e9741817 100644
--- a/freebsd/sys/netinet/libalias/alias_ftp.c
+++ b/freebsd/sys/netinet/libalias/alias_ftp.c
@@ -151,6 +151,9 @@ protohandler_in(struct libalias *la, struct ip *pip, struct alias_data *ah)
 	return (0);
 }
 
+#ifdef __rtems__
+static
+#endif /* __rtems__ */
 struct proto_handler handlers[] = {
 	{
 	  .pri = 80,
diff --git a/freebsd/sys/netinet/libalias/alias_irc.c b/freebsd/sys/netinet/libalias/alias_irc.c
index 19337121..6b97aba9 100644
--- a/freebsd/sys/netinet/libalias/alias_irc.c
+++ b/freebsd/sys/netinet/libalias/alias_irc.c
@@ -120,6 +120,9 @@ protohandler(struct libalias *la, struct ip *pip, struct alias_data *ah)
 	return (0);
 }
 
+#ifdef __rtems__
+static
+#endif /* __rtems__ */
 struct proto_handler handlers[] = {
 	{
 	  .pri = 90,
diff --git a/freebsd/sys/netinet/libalias/alias_nbt.c b/freebsd/sys/netinet/libalias/alias_nbt.c
index 3d200cd4..73a6f41d 100644
--- a/freebsd/sys/netinet/libalias/alias_nbt.c
+++ b/freebsd/sys/netinet/libalias/alias_nbt.c
@@ -131,6 +131,9 @@ protohandler2out(struct libalias *la, struct ip *pip, struct alias_data *ah)
 }
 
 /* Kernel module definition. */
+#ifdef __rtems__
+static
+#endif /* __rtems__ */
 struct proto_handler handlers[] = {
 	{
 	  .pri = 130,
diff --git a/freebsd/sys/netinet/libalias/alias_pptp.c b/freebsd/sys/netinet/libalias/alias_pptp.c
index e3da53b7..14674baa 100644
--- a/freebsd/sys/netinet/libalias/alias_pptp.c
+++ b/freebsd/sys/netinet/libalias/alias_pptp.c
@@ -135,6 +135,9 @@ protohandlergreout(struct libalias *la, struct ip *pip, struct alias_data *ah)
 }
 
 /* Kernel module definition. */
+#ifdef __rtems__
+static
+#endif /* __rtems__ */
 struct proto_handler handlers[] = {
 	{
 	  .pri = 200,
diff --git a/freebsd/sys/netinet/libalias/alias_skinny.c b/freebsd/sys/netinet/libalias/alias_skinny.c
index 2cf235f2..9ef88779 100644
--- a/freebsd/sys/netinet/libalias/alias_skinny.c
+++ b/freebsd/sys/netinet/libalias/alias_skinny.c
@@ -80,6 +80,9 @@ protohandler(struct libalias *la, struct ip *pip, struct alias_data *ah)
 	return (0);
 }
 
+#ifdef __rtems__
+static
+#endif /* __rtems__ */
 struct proto_handler handlers[] = {
 	{
 	  .pri = 110,
diff --git a/freebsd/sys/netinet/libalias/alias_smedia.c b/freebsd/sys/netinet/libalias/alias_smedia.c
index e2798845..c9c1c678 100644
--- a/freebsd/sys/netinet/libalias/alias_smedia.c
+++ b/freebsd/sys/netinet/libalias/alias_smedia.c
@@ -164,6 +164,9 @@ protohandler(struct libalias *la, struct ip *pip, struct alias_data *ah)
 	return (0);
 }
 
+#ifdef __rtems__
+static
+#endif /* __rtems__ */
 struct proto_handler handlers[] = {
 	{
 	  .pri = 100,
-- 
2.24.1