From 2970ac7c378253a48790192a6df8cd26f04d50b3 Mon Sep 17 00:00:00 2001
From: Chris Johns <chrisj@rtems.org>
Date: Mon, 2 Aug 2021 18:16:23 +1000
Subject: [PATCH rtems-libbsd v4 04/19] kern-symbols: Add symbols from the
 everything build set

Update #4475
---
 .../machine/rtems-bsd-kernel-namespace.h      | 127 ++++++++++++++++++
 1 file changed, 127 insertions(+)

diff --git a/rtemsbsd/include/machine/rtems-bsd-kernel-namespace.h b/rtemsbsd/include/machine/rtems-bsd-kernel-namespace.h
index 70bcd29a..293c6115 100644
--- a/rtemsbsd/include/machine/rtems-bsd-kernel-namespace.h
+++ b/rtemsbsd/include/machine/rtems-bsd-kernel-namespace.h
@@ -111,9 +111,11 @@
 #define	M_CRYPTO_DATA _bsd_M_CRYPTO_DATA
 #define	M_DEVBUF _bsd_M_DEVBUF
 #define	M_EVDEV _bsd_M_EVDEV
+#define	M_FIXEDREGULATOR _bsd_M_FIXEDREGULATOR
 #define	M_GIF _bsd_M_GIF
 #define	M_GRE _bsd_M_GRE
 #define	M_IFADDR _bsd_M_IFADDR
+#define	M_IFLIB _bsd_M_IFLIB
 #define	M_IFMADDR _bsd_M_IFMADDR
 #define	M_IOV _bsd_M_IOV
 #define	M_IP6MADDR _bsd_M_IP6MADDR
@@ -132,6 +134,7 @@
 #define	M_OFWPROP _bsd_M_OFWPROP
 #define	M_PCB _bsd_M_PCB
 #define	M_PFHASH _bsd_M_PFHASH
+#define	M_REGULATOR _bsd_M_REGULATOR
 #define	M_RTABLE _bsd_M_RTABLE
 #define	M_RTWN_PRIV _bsd_M_RTWN_PRIV
 #define	M_SONAME _bsd_M_SONAME
@@ -292,6 +295,7 @@
 #define	_cv_wait _bsd__cv_wait
 #define	_cv_wait_sig _bsd__cv_wait_sig
 #define	_cv_wait_unlock _bsd__cv_wait_unlock
+#define	_kevent _bsd__kevent
 #define	_libmd_SHA224_Final _bsd__libmd_SHA224_Final
 #define	_libmd_SHA224_Init _bsd__libmd_SHA224_Init
 #define	_libmd_SHA224_Update _bsd__libmd_SHA224_Update
@@ -1686,6 +1690,7 @@
 #define	hid_start_parse _bsd_hid_start_parse
 #define	hmac_ipad_buffer _bsd_hmac_ipad_buffer
 #define	hmac_opad_buffer _bsd_hmac_opad_buffer
+#define	hostb_alloc_start _bsd_hostb_alloc_start
 #define	hz _bsd_hz
 #define	ic_printf _bsd_ic_printf
 #define	icmp6_ctloutput _bsd_icmp6_ctloutput
@@ -2279,6 +2284,54 @@
 #define	ifhwioctl _bsd_ifhwioctl
 #define	ifindex_table _bsd_ifindex_table
 #define	ifioctl _bsd_ifioctl
+#define	iflib_add_int_delay_sysctl _bsd_iflib_add_int_delay_sysctl
+#define	iflib_admin_intr_deferred _bsd_iflib_admin_intr_deferred
+#define	iflib_config_gtask_deinit _bsd_iflib_config_gtask_deinit
+#define	iflib_config_gtask_init _bsd_iflib_config_gtask_init
+#define	iflib_ctx_lock_get _bsd_iflib_ctx_lock_get
+#define	iflib_device_attach _bsd_iflib_device_attach
+#define	iflib_device_deregister _bsd_iflib_device_deregister
+#define	iflib_device_detach _bsd_iflib_device_detach
+#define	iflib_device_iov_add_vf _bsd_iflib_device_iov_add_vf
+#define	iflib_device_iov_init _bsd_iflib_device_iov_init
+#define	iflib_device_iov_uninit _bsd_iflib_device_iov_uninit
+#define	iflib_device_probe _bsd_iflib_device_probe
+#define	iflib_device_probe_vendor _bsd_iflib_device_probe_vendor
+#define	iflib_device_register _bsd_iflib_device_register
+#define	iflib_device_resume _bsd_iflib_device_resume
+#define	iflib_device_shutdown _bsd_iflib_device_shutdown
+#define	iflib_device_suspend _bsd_iflib_device_suspend
+#define	iflib_dma_alloc _bsd_iflib_dma_alloc
+#define	iflib_dma_alloc_align _bsd_iflib_dma_alloc_align
+#define	iflib_dma_alloc_multi _bsd_iflib_dma_alloc_multi
+#define	iflib_dma_free _bsd_iflib_dma_free
+#define	iflib_dma_free_multi _bsd_iflib_dma_free_multi
+#define	iflib_get_dev _bsd_iflib_get_dev
+#define	iflib_get_flags _bsd_iflib_get_flags
+#define	iflib_get_ifp _bsd_iflib_get_ifp
+#define	iflib_get_media _bsd_iflib_get_media
+#define	iflib_get_rx_mbuf_sz _bsd_iflib_get_rx_mbuf_sz
+#define	iflib_get_sctx _bsd_iflib_get_sctx
+#define	iflib_get_softc _bsd_iflib_get_softc
+#define	iflib_get_softc_ctx _bsd_iflib_get_softc_ctx
+#define	iflib_in_detach _bsd_iflib_in_detach
+#define	iflib_io_tqg_attach _bsd_iflib_io_tqg_attach
+#define	iflib_iov_intr_deferred _bsd_iflib_iov_intr_deferred
+#define	iflib_irq_alloc _bsd_iflib_irq_alloc
+#define	iflib_irq_alloc_generic _bsd_iflib_irq_alloc_generic
+#define	iflib_irq_free _bsd_iflib_irq_free
+#define	iflib_led_create _bsd_iflib_led_create
+#define	iflib_link_state_change _bsd_iflib_link_state_change
+#define	iflib_pseudo_deregister _bsd_iflib_pseudo_deregister
+#define	iflib_pseudo_register _bsd_iflib_pseudo_register
+#define	iflib_pseudodriver _bsd_iflib_pseudodriver
+#define	iflib_request_reset _bsd_iflib_request_reset
+#define	iflib_rx_intr_deferred _bsd_iflib_rx_intr_deferred
+#define	iflib_set_detach _bsd_iflib_set_detach
+#define	iflib_set_mac _bsd_iflib_set_mac
+#define	iflib_softirq_alloc_generic _bsd_iflib_softirq_alloc_generic
+#define	iflib_stop _bsd_iflib_stop
+#define	iflib_tx_intr_deferred _bsd_iflib_tx_intr_deferred
 #define	ifma_restart _bsd_ifma_restart
 #define	ifmedia_add _bsd_ifmedia_add
 #define	ifmedia_baudrate _bsd_ifmedia_baudrate
@@ -2287,6 +2340,13 @@
 #define	ifmedia_list_add _bsd_ifmedia_list_add
 #define	ifmedia_removeall _bsd_ifmedia_removeall
 #define	ifmedia_set _bsd_ifmedia_set
+#define	ifmp_ring_alloc _bsd_ifmp_ring_alloc
+#define	ifmp_ring_check_drainage _bsd_ifmp_ring_check_drainage
+#define	ifmp_ring_enqueue _bsd_ifmp_ring_enqueue
+#define	ifmp_ring_free _bsd_ifmp_ring_free
+#define	ifmp_ring_is_idle _bsd_ifmp_ring_is_idle
+#define	ifmp_ring_is_stalled _bsd_ifmp_ring_is_stalled
+#define	ifmp_ring_reset_stats _bsd_ifmp_ring_reset_stats
 #define	ifnet _bsd_ifnet
 #define	ifnet_byindex _bsd_ifnet_byindex
 #define	ifnet_byindex_locked _bsd_ifnet_byindex_locked
@@ -2336,6 +2396,21 @@
 #define	iicdev_writeto _bsd_iicdev_writeto
 #define	im6o_mc_filter _bsd_im6o_mc_filter
 #define	imo_multi_filter _bsd_imo_multi_filter
+#define	imx6_anatop_write_4 _bsd_imx6_anatop_write_4
+#define	imx6_ccm_sata_enable _bsd_imx6_ccm_sata_enable
+#define	imx_ccm_ahb_hz _bsd_imx_ccm_ahb_hz
+#define	imx_ccm_ecspi_hz _bsd_imx_ccm_ecspi_hz
+#define	imx_ccm_get_cacrr _bsd_imx_ccm_get_cacrr
+#define	imx_ccm_hdmi_enable _bsd_imx_ccm_hdmi_enable
+#define	imx_ccm_ipg_hz _bsd_imx_ccm_ipg_hz
+#define	imx_ccm_ipu_enable _bsd_imx_ccm_ipu_enable
+#define	imx_ccm_perclk_hz _bsd_imx_ccm_perclk_hz
+#define	imx_ccm_sdhci_hz _bsd_imx_ccm_sdhci_hz
+#define	imx_ccm_set_cacrr _bsd_imx_ccm_set_cacrr
+#define	imx_ccm_ssi_configure _bsd_imx_ccm_ssi_configure
+#define	imx_ccm_uart_hz _bsd_imx_ccm_uart_hz
+#define	imx_ccm_usb_enable _bsd_imx_ccm_usb_enable
+#define	imx_ccm_usbphy_enable _bsd_imx_ccm_usbphy_enable
 #define	in4_cksum _bsd_in4_cksum
 #define	in6_addrscope _bsd_in6_addrscope
 #define	in6_are_prefix_equal _bsd_in6_are_prefix_equal
@@ -2936,6 +3011,16 @@
 #define	led_create_state _bsd_led_create_state
 #define	led_destroy _bsd_led_destroy
 #define	led_set _bsd_led_set
+#define	legacy_pcib_alloc_msi _bsd_legacy_pcib_alloc_msi
+#define	legacy_pcib_alloc_msix _bsd_legacy_pcib_alloc_msix
+#define	legacy_pcib_alloc_resource _bsd_legacy_pcib_alloc_resource
+#define	legacy_pcib_driver _bsd_legacy_pcib_driver
+#define	legacy_pcib_map_msi _bsd_legacy_pcib_map_msi
+#define	legacy_pcib_maxslots _bsd_legacy_pcib_maxslots
+#define	legacy_pcib_read_config _bsd_legacy_pcib_read_config
+#define	legacy_pcib_read_ivar _bsd_legacy_pcib_read_ivar
+#define	legacy_pcib_write_config _bsd_legacy_pcib_write_config
+#define	legacy_pcib_write_ivar _bsd_legacy_pcib_write_ivar
 #define	legal_vif_num _bsd_legal_vif_num
 #define	lem_txrx _bsd_lem_txrx
 #define	link_alloc_sdl _bsd_link_alloc_sdl
@@ -3293,6 +3378,7 @@
 #define	nvme_request_zone _bsd_nvme_request_zone
 #define	nvme_retry_count _bsd_nvme_retry_count
 #define	nvme_shutdown _bsd_nvme_shutdown
+#define	nvme_strvis _bsd_nvme_strvis
 #define	nvme_sysctl_initialize_ctrlr _bsd_nvme_sysctl_initialize_ctrlr
 #define	nvme_unregister_consumer _bsd_nvme_unregister_consumer
 #define	nvme_use_nvd _bsd_nvme_use_nvd
@@ -3339,6 +3425,7 @@
 #define	ofw_iicbus_driver _bsd_ofw_iicbus_driver
 #define	ofw_parse_bootargs _bsd_ofw_parse_bootargs
 #define	ofw_reg_to_paddr _bsd_ofw_reg_to_paddr
+#define	ofw_regulator_bus_driver _bsd_ofw_regulator_bus_driver
 #define	ofwbus_driver _bsd_ofwbus_driver
 #define	ofwgpiobus_devclass _bsd_ofwgpiobus_devclass
 #define	ohci_detach _bsd_ohci_detach
@@ -3773,6 +3860,8 @@
 #define	pru_soreceive_notsupp _bsd_pru_soreceive_notsupp
 #define	pru_sosend_notsupp _bsd_pru_sosend_notsupp
 #define	qgroup_config _bsd_qgroup_config
+#define	qgroup_if_config_tqg _bsd_qgroup_if_config_tqg
+#define	qgroup_if_io_tqg _bsd_qgroup_if_io_tqg
 #define	qgroup_softirq _bsd_qgroup_softirq
 #define	r12a_beacon_init _bsd_r12a_beacon_init
 #define	r12a_beacon_set_rate _bsd_r12a_beacon_set_rate
@@ -4005,6 +4094,42 @@
 #define	register_tcp_functions_as_name _bsd_register_tcp_functions_as_name
 #define	register_tcp_functions_as_names _bsd_register_tcp_functions_as_names
 #define	registered_toedevs _bsd_registered_toedevs
+#define	regnode_class _bsd_regnode_class
+#define	regnode_create _bsd_regnode_create
+#define	regnode_disable _bsd_regnode_disable
+#define	regnode_enable _bsd_regnode_enable
+#define	regnode_fixed_class _bsd_regnode_fixed_class
+#define	regnode_fixed_register _bsd_regnode_fixed_register
+#define	regnode_get_device _bsd_regnode_get_device
+#define	regnode_get_flags _bsd_regnode_get_flags
+#define	regnode_get_name _bsd_regnode_get_name
+#define	regnode_get_parent _bsd_regnode_get_parent
+#define	regnode_get_parent_name _bsd_regnode_get_parent_name
+#define	regnode_get_softc _bsd_regnode_get_softc
+#define	regnode_get_stdparam _bsd_regnode_get_stdparam
+#define	regnode_get_voltage _bsd_regnode_get_voltage
+#define	regnode_method_check_voltage _bsd_regnode_method_check_voltage
+#define	regnode_register _bsd_regnode_register
+#define	regnode_set_constraint _bsd_regnode_set_constraint
+#define	regnode_set_voltage _bsd_regnode_set_voltage
+#define	regnode_status _bsd_regnode_status
+#define	regnode_stop _bsd_regnode_stop
+#define	regnode_topo_slock _bsd_regnode_topo_slock
+#define	regnode_topo_unlock _bsd_regnode_topo_unlock
+#define	regnode_topo_xlock _bsd_regnode_topo_xlock
+#define	regulator_check_voltage _bsd_regulator_check_voltage
+#define	regulator_disable _bsd_regulator_disable
+#define	regulator_enable _bsd_regulator_enable
+#define	regulator_get_by_id _bsd_regulator_get_by_id
+#define	regulator_get_by_name _bsd_regulator_get_by_name
+#define	regulator_get_name _bsd_regulator_get_name
+#define	regulator_get_voltage _bsd_regulator_get_voltage
+#define	regulator_range_sel8_to_volt _bsd_regulator_range_sel8_to_volt
+#define	regulator_range_volt_to_sel8 _bsd_regulator_range_volt_to_sel8
+#define	regulator_release _bsd_regulator_release
+#define	regulator_set_voltage _bsd_regulator_set_voltage
+#define	regulator_status _bsd_regulator_status
+#define	regulator_stop _bsd_regulator_stop
 #define	resource_disabled _bsd_resource_disabled
 #define	resource_find_match _bsd_resource_find_match
 #define	resource_int_value _bsd_resource_int_value
@@ -4866,6 +4991,7 @@
 #define	sysctl___hw_fdt _bsd_sysctl___hw_fdt
 #define	sysctl___hw_nvme _bsd_sysctl___hw_nvme
 #define	sysctl___hw_pci _bsd_sysctl___hw_pci
+#define	sysctl___hw_regulator _bsd_sysctl___hw_regulator
 #define	sysctl___hw_sdhci _bsd_sysctl___hw_sdhci
 #define	sysctl___hw_usb _bsd_sysctl___hw_usb
 #define	sysctl___hw_usb_rsu _bsd_sysctl___hw_usb_rsu
@@ -5616,6 +5742,7 @@
 #define	usbd_transfer_timeout_ms _bsd_usbd_transfer_timeout_ms
 #define	usbd_transfer_unsetup _bsd_usbd_transfer_unsetup
 #define	usbd_xfer_clr_flag _bsd_usbd_xfer_clr_flag
+#define	usbd_xfer_frame_allow_cache_line_blow_up _bsd_usbd_xfer_frame_allow_cache_line_blow_up
 #define	usbd_xfer_frame_data _bsd_usbd_xfer_frame_data
 #define	usbd_xfer_frame_len _bsd_usbd_xfer_frame_len
 #define	usbd_xfer_get_fps_shift _bsd_usbd_xfer_get_fps_shift
-- 
2.24.1